[leetcode]: 501. Find Mode in Binary Search Tree

1.题目

Given a binary search tree (BST) with duplicates, find all the mode(s) (the most frequently occurred element) in the given BST.

Assume a BST is defined as follows:

The left subtree of a node contains only nodes with keys less than or equal to the node’s key.
The right subtree of a node contains only nodes with keys greater than or equal to the node’s key.
Both the left and right subtrees must also be binary search trees.
For example:
Given BST [1,null,2,2],

1
\
 2
/
2

return [2].

给一棵二叉搜索树,有重复元素。找出其中重复次数最多的元素。如果有多个重复次数一样的元素,则放在一个列表中作为返回结果。

2.分析

这题考察的是BST的中序遍历,中序遍历的元素是有序的,在遍历的过程中统计元素出现的次数即可。

3.代码

中序遍历–迭代

/**
 * Definition for a binary tree node.
 * struct TreeNode {
 *     int val;
 *     TreeNode *left;
 *     TreeNode *right;
 *     TreeNode(int x) : val(x), left(NULL), right(NULL) {}
 * };
 */
class Solution {
public:
    vector<int> findMode(TreeNode* root) {
        vector<int> mode;
        if (root == NULL)
            return mode;
        int max_c = -1;//记录历史最多出现次数
        int last_v = INT_MIN;
        int count = 1;//当前值出现的次数
        stack<TreeNode*> nodes;
        while (!nodes.empty() || root) {
            if (root) {
                nodes.push(root);
                root = root->left;//先遍历到左子树最下边
            }
            else {
                root = nodes.top();
                nodes.pop();
                if (last_v != INT_MIN) {
                    if (root->val == last_v)
                        ++count;
                    else
                        count = 1;
                }
                if (count > max_c)
                {
                    max_c = count;
                    mode.erase(mode.begin(), mode.end());
                    mode.push_back(root->val);
                }
                else if (count == max_c)
                    mode.push_back(root->val);
                last_v = root->val;
                root = root->right;//转到右子树
            }
        }
        return mode;
    }
};

中序遍历–递归

class Solution {
public:
    void inOrder(TreeNode* root, vector<int>&mode,int& val,int& count,int& maxc) {
        if (root == NULL)
            return;
        inOrder(root->left,mode,val,count,maxc);
        if (val != INT_MIN) {
            if (val == root->val)
                ++count;
            else
                count = 1;
        }
        if (count > maxc) {
            maxc = count;
            mode.erase(mode.begin(), mode.end());//出现次数更多的元素,清空容器
            mode.push_back(root->val);
        }
        else if (count == maxc)
            mode.push_back(root->val);
        val = root->val;
        inOrder(root->right, mode, val, count, maxc);
    }
    vector<int> findMode(TreeNode* root) {
        vector<int> mode;
        if (root == NULL)
            return mode;
        int maxc = -1;
        int count = 1;
        int val = INT_MIN;
        inOrder(root, mode, val, count, maxc);
        return mode;
    }
};
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
给定一个整数数组 nums 和一个目标值 target,要求在数组中找出两个数的和等于目标值,并返回这两个数的索引。 思路1:暴力法 最简单的思路是使用两层循环遍历数组的所有组合,判断两个数的和是否等于目标值。如果等于目标值,则返回这两个数的索引。 此方法的时间复杂度为O(n^2),空间复杂度为O(1)。 思路2:哈希表 为了优化时间复杂度,可以使用哈希表来存储数组中的元素和对应的索引。遍历数组,对于每个元素nums[i],我们可以通过计算target - nums[i]的值,查找哈希表中是否存在这个差值。 如果存在,则说明找到了两个数的和等于目标值,返回它们的索引。如果不存在,将当前元素nums[i]和它的索引存入哈希表中。 此方法的时间复杂度为O(n),空间复杂度为O(n)。 思路3:双指针 如果数组已经排序,可以使用双指针的方法来求解。假设数组从小到大排序,定义左指针left指向数组的第一个元素,右指针right指向数组的最后一个元素。 如果当前两个指针指向的数的和等于目标值,则返回它们的索引。如果和小于目标值,则将左指针右移一位,使得和增大;如果和大于目标值,则将右指针左移一位,使得和减小。 继续移动指针,直到找到两个数的和等于目标值或者左指针超过了右指针。 此方法的时间复杂度为O(nlogn),空间复杂度为O(1)。 以上三种方法都可以解决问题,选择合适的方法取决于具体的应用场景和要求。如果数组规模较小并且不需要考虑额外的空间使用,则暴力法是最简单的方法。如果数组较大或者需要优化时间复杂度,则哈希表或双指针方法更合适。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值